<?php
if(!defined('InEmpireCMS'))
{
	exit();
}

eCheckCloseMods('pay');//关闭模块
//------------------ 参数开始 ------------------
$my_plugin_id ='empire';
$phome = null;
if(isset($_SERVER['REQUEST_URI'])){
    if(strpos($_SERVER['REQUEST_URI'],'api/ShopPay')!==false){
        $phome = 'ShopPay';
    }else if(strpos($_SERVER['REQUEST_URI'],'api/BuyGroupPay.php')!==false) {
        $phome = 'BuyGroupPay';
    }else if(strpos($_SERVER['REQUEST_URI'],'api/pay.php')!==false) {
        $phome=isset($_POST['phome'])?$_POST['phome']:null;
    }
}
if(!$phome){
    $phome=getcvar('payphome');
}

$user=array();
if($phome=='PayToFen'||$phome=='PayToMoney'||$phome=='BuyGroupPay')
{
    $user=islogin();//是否登陆
}
if(empty($phome)){

    printerror('Refresh the page and try again!','../../ShopSys/buycar/',1,0,1);
    exit;
}

$attach=array(
    'phome'=>$phome,
    'user_id'=>isset($user['userid'])?$user['userid']:0,
);

if($phome=='ShopPay'){
    $attach['paymoneyddid'] = getcvar('paymoneyddid');
}

if($phome=='BuyGroupPay'){
//    $attach['paymoneybgid'] = getcvar('paymoneybgid');
    $attach['paymoneybgid'] = intval($_POST['id']);
}

require_once 'api.php';
$trade_order_id = $ddno?$ddno:time();//商户网站内部ID，此处time()是演示数据
$appid              = $payr['payuser'];//测试账户，仅支持一元内支付
$appsecret          = $payr['paykey'];//测试账户，仅支持一元内支付
//$productname="支付订单号:".$ddno;
$productname="充值账号:".$user['username']." 类型:".$buyr['gname'];
if($phome=='PayToMoney'){
    $productname="充值类型:UID:".$user['userid'].",UName:".$user['username'];
}
$data=array(
    'version'   => '1.1',//固定值，api 版本，目前暂时是1.1
    'lang'       => 'zh-cn', //必须的，zh-cn或en-us 或其他，根据语言显示页面
    'plugins'   => $my_plugin_id,//必须的，根据自己需要自定义插件ID，唯一的，匹配[a-zA-Z\d\-_]+
    'appid'     => $appid, //必须的，APPID
    'trade_order_id'=> $trade_order_id, //必须的，网站订单ID，唯一的，匹配[a-zA-Z\d\-_]+
    'attach'=>serialize($attach),
    'payment'   => 'alipay',//必须的，支付接口标识：wechat(微信接口)|alipay(支付宝接口)
    'total_fee' => $money,//人民币，单位精确到分(测试账户只支持1元内付款)
    'title'     => $productname, //必须的，订单标题，长度32或以内
    'time'      => time(),//必须的，当前时间戳，根据此字段判断订单请求是否已超时，防止第三方攻击服务器
    'notify_url'=>  $PayReturnUrlQz.'e/payapi/openalipay/payend.php', //必须的，支付成功异步回调接口
    'return_url'=> $PayReturnUrlQz.'e/payapi/openalipay/success.php',//必须的，支付成功后的跳转地址
    'callback_url'=> $PayReturnUrlQz.'e/ShopSys/buycar/',//必须的，支付发起地址（未支付或支付失败，系统会会跳到这个地址让用户修改支付信息）
    'nonce_str' => str_shuffle(time())//必须的，随机字符串，作用：1.避免服务器缓存，2.防止安全密钥被猜测出来
);

$hashkey =$appsecret;
$data['hash']     = XH_Payment_Api::generate_xh_hash($data,$hashkey);
/**
 * 个人支付宝/微信即时到账，支付网关：https://pay.xunhupay.com
 * 微信支付宝代收款，需提现，支付网关：https://pay.wordpressopen.com
 */
$url              = $payr['payemail'].'/payment/do.html';

try {
    $response     = XH_Payment_Api::http_post($url, http_build_query($data));

    $result       = $response?json_decode($response,true):null;
    if(!$result){
        throw new Exception('Internal server error',500);
    }
     
    $hash         = XH_Payment_Api::generate_xh_hash($result,$hashkey);
    if(!isset( $result['hash'])|| $hash!=$result['hash']){
        throw new Exception(__('Invalid sign!',XH_Wechat_Payment),40029);
    }

    if($result['errcode']!=0){
        throw new Exception($result['errmsg'],$result['errcode']);
    }


    $pay_url =$result['url'];
    header("location: $pay_url",true,302);
    exit;
} catch (Exception $e) {
    echo "errcode:{$e->getCode()},errmsg:{$e->getMessage()}";
    //TODO:处理支付调用异常的情况
}
